<?PHP
/*
+ ----------------------------------------------------------------------------+
|     FDE Parser Template System
|
|     Zudilin Vladimir, 2007-2008
|     http://fdstar.net/
|     fde-parser@fdstar.net
|
|     Released under the terms and conditions of the
|     GNU General Public License V 2.1 (http://gnu.org/).
|
+----------------------------------------------------------------------------+
*/   
class parser
{
    var $vars = array(),
    $files = array(),
    $cache,
    $path,
    $perm,
    $debug = false,
    $replaces_array;
    function parser()
    {
        if(!defined('tpl_cache') || !defined('tpl_path'))
        {
            beauty_die('Please, define constant: "tpl_cache" - path to tpl cache files and constant: "tpl_path" - path to templates  files');
        }
        if(!defined('FDE_PARSER'))
        {
            define('FDE_PARSER', true);
        }
        $this->replaces_array = array();
        $this->cache = tpl_cache;
        $this->path = tpl_path;
        $this->debug = defined('tpl_debug') ? tpl_debug : $this->debug;
        $this->perm = defined('tpl_perm') ? tpl_perm : 0777;
        
        $this->replaces_array['#\{strip\}(.*?)\{/strip\}#sieS'] = 'parser::clean(\'\1\')';
        $this->replaces_array['#\{include[\s]*file[\s]*=[\s]*"(.*?)"[\s]*\}#sieS'] = 'parser::includes(\'\1\', $tpl)';
        $this->replaces_array['#\{php\}(.*?)\{/php\}#siS'] = "<?PHP \\1 ?>";
        $this->replaces_array['#\{assign[\s]+var=\"([a-z_][a-z0-9_]*)\"[\s]+value=(.*?)\}#siS'] = "<?PHP \$\\1=\\2;?>";
        $this->replaces_array['#\{cycle[\s]*\"(.*?)\"[\s]*,[\s]*\"(.*?)\"[\s]*\}#sieS'] = 'parser::cycle(\'\1\',\'\2\')';
        $this->replaces_array['#\{if[\s]*(.*?)[\s]*\}#siS'] = "<?PHP if(\\1): ?>";
        $this->replaces_array['#\{/if\}#siS'] = "<?PHP endif; ?>";
        $this->replaces_array['#\{else\}#siS'] = "<?PHP else:?>";
        $this->replaces_array['#\{foreach[\s]*(.*?)[\s]*\}#siS'] = "<?PHP foreach(\\1): ?>";
        $this->replaces_array['#\{/foreach\}#siS'] = "<?PHP endforeach; ?>";
        $this->replaces_array['#\{elseif[\s]*(.*?)[\s]*\}#siS'] = "<?PHP elseif(\\1): ?>";
        $this->replaces_array['#\{(\$[a-z0-9_]+[^\{\}]*)\}#siUS'] = "<?PHP echo \\1; ?>";
        $this->replaces_array = array('from'=> array_keys($this->replaces_array), 'to'=>array_values($this->replaces_array));
    }
    function assign($var, $value, $tpl = false)
    {
        $tpl = $tpl ? $tpl : 'default';
        if(!isset($this->vars[$tpl]))
        {
            $this->vars[$tpl] = array();
        }
        $this->vars[$tpl][$var] = $value;
    }
    function includes($f, $tpl)
    {
        return "<?PHP global \$FDE_TPL_CLASS;\$FDE_TPL_CLASS->display('{$f}','{$tpl}'); ?>";
    }
    function clean($t)
    {
        $t = stripslashes($t);
        $t = trim(preg_replace('/\\s+/', ' ', $t));
        return $t;
    }
    function cycle($t1,$t2)
    {
        static $sc;
        $t1 = stripslashes($t1);
        $t2 = stripslashes($t2);
        $sc = !isset($sc)?0:$sc+1;
        $t1 = str_replace("\"", "\\\"", $t1);
        $t2 = str_replace("\"", "\\\"", $t2);
        return "<?PHP global \$FDE_CYCLES;\$FDE_CYCLES=isset(\$FDE_CYCLES)?\$FDE_CYCLES:array();\$FDE_CYCLES[{$sc}]=\$FDE_CYCLES[{$sc}]==\"{$t1}\"?\"{$t2}\":\"{$t1}\"; echo \$FDE_CYCLES[{$sc}]; ?>";
    }
    function fetch($file, $tpl = false)
    {
        global $FDE_TPL_CLASS;
        $FDE_TPL_CLASS = $this;
        $t = '';
        $tpl = $tpl ? $tpl : 'default';
        $this->global_assigns($this->vars[$tpl]);
        if(!isset($this->files[$file]))
        {
            $this->files[$file] = array();
            $this->files[$file]['function'] = 'tpl_'. md5($file);
            $this->files[$file]['tpl'] = $this->path. $file;
            $this->files[$file]['cache'] = $this->cache. $this->files[$file]['function']. '.php';
            if($this->files[$file]['require'] = file_exists($this->files[$file]['cache']))
            {
                if($this->debug)
                {
                    $this->files[$file]['require'] = filemtime($this->files[$file]['cache'])>filemtime($this->files[$file]['tpl']);
                }
            }
            $this->files[$file]['content'] = !$this->files[$file]['require'] ? @file_get_contents($this->files[$file]['tpl']) : false;
            $this->files[$file]['evaled'] = false;
        }
        //$this->files[$file]['evaled'] = function_exists($this->files[$file]['function']);
        $vars = &$this->vars[$tpl];
        
        ob_start();
        if($this->files[$file]['require'])
        {
            require_once($this->files[$file]['cache']);
            eval("@{$this->files[$file]['function']}(\$vars);");
        }
        else
        {
            $tpl_c = &$this->files[$file]['content'];
            if(!$this->files[$file]['evaled'])
            {
                $tpl_c = preg_replace($this->replaces_array['from'], $this->replaces_array['to'], $tpl_c);
                $tpl_c = "\nfunction {$this->files[$file]['function']}(&\$a) {@extract(\$a); ?>{$tpl_c}<?PHP }";
                if($f = @fopen($this->files[$file]['cache'], 'w+'))
                {
                    @fwrite($f, "<?PHP if(!defined('FDE_PARSER'))die('Hack attempt!'); {$tpl_c} ?>");
                    @fclose($f);
                    @chmod($this->files[$file]['cache'], $this->perm);
                }
                @eval($tpl_c);
                $this->files[$file]['evaled'] = true;
            }
            @eval("@{$this->files[$file]['function']}(\$vars);");
        }
        $t.= ob_get_contents();
        ob_end_clean();
        return $t;
    }
    function display($file, $tpl = false)
    {
        $tpl = $tpl ? $tpl : 'default';
        echo $this->fetch($file, $tpl);
    }
    function global_assigns(&$vars)
    {
        //$vars['webroot'] = WEBROOT;
    }
}
?>