<?PHP
/*
+ ----------------------------------------------------------------------------+
|     FDE Parser Template System
|
|     Zudilin Vladimir, 2007-2008
|     http://fdstar.net/
|     fde-parser@fdstar.net
|
|     Released under the terms and conditions of the
|     GNU General Public License V 2.1 (http://gnu.org/).
|
+----------------------------------------------------------------------------+
*/

define('ROOT', rtrim(str_replace('\\', '/', dirname(__FILE__)), '/'). '/');
require_once(ROOT. 'inc/tpl.class.php');

$webroot = str_replace('\\','/',dirname($_SERVER['SCRIPT_NAME']));
$webroot = ($webroot=='/')?'/':$webroot.'/'; 
define('WEBROOT', $webroot);

define('tpl_cache', ROOT. 'cache/');
define('tpl_path', ROOT. 'tpl/');
define('tpl_debug', true);
define('tpl_perm', 0777);

$tpl = new parser();

$sample_news = array(
    '1' => array(
        'news_title' => 'first news',
        'news_content' => str_repeat('first news content ', 100)
    ),
    '2' => array(
        'news_title' => 'second news',
        'news_content' => str_repeat('second news content ', 100)
    ),
    '3' => array(
        'news_title' => 'third news',
        'news_content' => str_repeat('third news content ', 100)
    ),
    '4' => array(
        'news_title' => 'fourth news',
        'news_content' => str_repeat('fourth news content ', 100)
    ),
    '5' => array(
        'news_title' => 'fifth news',
        'news_content' => str_repeat('fifth news content ', 100)
    ),
    '6' => array(
        'news_title' => 'sixth news',
        'news_content' => str_repeat('sixth news content ', 100)
    ),
    '7' => array(
        'news_title' => 'seventh news',
        'news_content' => str_repeat('seventh news content ', 100)
    ),
);


$tpl->assign('webroot', WEBROOT);
$tpl->assign('title_page', 'FDE Parser - simple and powerful!');
$tpl->assign('news', $sample_news);

echo $tpl->fetch('template.tpl');

?>